clear; close all; clc
% solve dynamic MINLP problem
addpath('apm')

% specify server and application name
s = 'http://byu.apmonitor.com';
%s = 'http://127.0.0.1/';
a = ['lotka' int2str(rand()*10000)];

apm(s,a,'clear all');
apm_load(s,a,'lotka_volterra.apm');
csv_load(s,a,'lotka_volterra.csv');

apm_option(s,a,'nlc.imode',6);             % Nonlinear control / dynamic optimization
%apm_option(s,a,'nlc.max_iter',2000);       % Maximum iteration: >=1, specified in apopt.opt
apm_option(s,a,'nlc.nodes',3);

apm_info(s,a,'MV','int_w');                % M or MV = Manipulated variable - independent variable over time horizon
apm_option(s,a,'int_w.status',1);          % Status: 1=ON, 0=OFF
apm_option(s,a,'int_w.mv_type',0);          % MV Type = Zero Order Hold

apm_option(s,a,'nlc.solver',1);            % 1 = APOPT

output = apm(s,a,'solve');            
disp(output)

y = apm_sol(s,a); z1 = y.x;

figure(1)

stairs(z1.time,z1.int_w,'r-','LineWidth',2)
hold on

plot(z1.time,z1.x0,'b-','LineWidth',2)
hold on

plot(z1.time,z1.x1,'k-','LineWidth',2)
hold on

plot(z1.time,z1.x2,'G-','LineWidth',2)
legend('w (binary 0-1)','x0','x1','x2')

grid on

xlabel('Time')
ylabel('Parameters')
